#include <iostream>
#include <vector>

using namespace std;

int main()
{
    const size_t SCREEN_WIDTH = 80;
    const size_t MAX_ASTERISK = SCREEN_WIDTH - 3 - 1;

    int max_count=0;

    char grafic_symbol = '*';
    char axis_symbol = '|';
    char correcting_symbol = ' ';

    cout<<"Enter a grafic_symbol";
    cin>>grafic_symbol;
    cout<<"Enter a axis_symbol";
    cin>>axis_symbol;
    cout<<"Enter a correcting_symbol";
    cin>>correcting_symbol;

    int count;
    size_t number_count;
    cerr << "Enter number count: ";
    cin >> number_count;
    size_t bin_count;
    cerr << "Enter bin count: ";
    cin >> bin_count;
    vector<double> numbers(number_count);
    vector<size_t> bins(bin_count);
    for (int i=0; i<number_count; i++)
    {
        cin>>numbers[i];
    }

    double min = numbers[0];
    double max = numbers[0];
    for (double x : numbers)
    {
        if (x < min)
        {
            min = x;
        }
        else if (x > max)
        {
            max = x;
        }
    }
    double bin_size = (max - min) / bin_count;
    for (size_t i = 0; i < number_count; i++)
    {
        bool found = false;
        for (size_t j = 0; (j < bin_count - 1) && !found; j++)
        {
            auto lo = min + j * bin_size;
            auto hi = min + (j + 1) * bin_size;
            if ((lo <= numbers[i]) && (numbers[i] < hi))
            {
                bins[j]++;
                found = true;
            }

        }
        if (!found)
            {
                bins[bin_count - 1]++;
            }
    }

    for (int i =0; i<bin_count;i++){
        if (bins[i]>max_count){
            max_count=bins[i];
        }
    }

    cout<<max_count<<endl;

    if (max_count>MAX_ASTERISK){
        for (int i=0; i<bin_count; i++){
            size_t height = MAX_ASTERISK * (static_cast<double>(bins[i]) / max_count);
            if (bins[i]<10){
                cout<<correcting_symbol<<correcting_symbol<<bins[i]<<axis_symbol;
                for (int j=0;j<height;j++){
                    cout<<grafic_symbol;
                }
                cout<<endl;
            }
            else if(bins[i]<100){
               cout<<correcting_symbol<<bins[i]<<axis_symbol;
                for (int j=0;j<height;j++){
                    cout<<grafic_symbol;
                }
                cout<<endl;
            }
            else{
                cout<<bins[i]<<axis_symbol;
                for (int j=0;j<height;j++){
                    cout<<grafic_symbol;
                }
                cout<<endl;
            }

        }
    }else{
        for (int i=0; i<bin_count; i++){
            if (bins[i]<10){
                cout<<correcting_symbol<<correcting_symbol<<bins[i]<<axis_symbol;
                for (int j=0;j<bins[i];j++){
                    cout<<grafic_symbol;
                }
                cout<<endl;
            }
            else if(bins[i]<100){
               cout<<correcting_symbol<<bins[i]<<axis_symbol;
                for (int j=0;j<bins[i];j++){
                    cout<<grafic_symbol;
                }
                cout<<endl;
            }
            else{
                cout<<bins[i]<<axis_symbol;
                for (int j=0;j<bins[i];j++){
                    cout<<grafic_symbol;
                }
                cout<<endl;
            }

        }
    }
}
